/*
 * This is a very simple C program used to probe the PCI bus, and compare the
 * vendor and model ID of every card found against the pcitable ASCII
 * database. From there it pulls the correct module name, and prints all of
 * the module names that were found for your system.
 *
 * Written by: Greg Kurtzer <greg@caosity.org>
 * License: GPL
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/utsname.h>
#include <ctype.h>
#include <sys/types.h>
#include <dirent.h>
#include <linux/pci_ids.h>
#include <unistd.h>


#include "detect.h"
#include "config.h"


void usage(char *program) {
        printf("usage: %s [options]\n"
               "\n"
	       "Detect is a program used for identifing the needed kernel modules\n"
	       "needed for your system. It compares your hardware against the\n"
	       "currently running kernel's pcimap, and reports the findings.\n\n"
               "[options]\n"
               "   -q                  Don't show device classes\n"
               "   -i                  Show the PCI IDs\n"
               "   -a                  Show the PCI address\n"
               "   -h                  This help\n\n"
	       "Written for cAos Linux by Greg Kurtzer <greg@caosity.org>\n",
               program);
        exit(0);
}

char * get_class(long long class_id) {
	static char out[BUFFSIZE];
	if ( class_id == 0x020000 ) {
		sprintf(out, "NETWORK");
	} else if ( class_id == 0x010000 ) {
		sprintf(out, "SCSI");
	} else if ( class_id == 0x010400 ) {
		sprintf(out, "SCSI");
	} else if ( class_id == 0x60700 ) {
		sprintf(out, "PCMCIA");
	} else if ( class_id == 0x30000 ) {
		sprintf(out, "DISPLAY");
	} else if ( class_id == 0x40100 ) {
		sprintf(out, "AUDIO");
	} else if ( class_id == 0x70300 ) {
		sprintf(out, "MODEM");
	} else if ( class_id == 0xc0300 ) {
		sprintf(out, "USB");
	} else if ( class_id == 0xc0310 ) {
		sprintf(out, "USB");
	} else if ( class_id == 0xc0320 ) {
		sprintf(out, "USB");
	} else if ( class_id == 0xc0010 ) {
		sprintf(out, "IEEE1394");
	} else if ( class_id == 0x60400 ) {
		sprintf(out, "PCI");
	} else {
		sprintf(out, "OTHER");
	}
	return(out);
}
